#ifndef UNIQUE_HPP
#define UNIQUE_HPP

#include "x_types.h"

#define SETUP
#define N_GAMES			3
#define	COMPRESS
#define MODE_LEN		16
#define MODE_LEN2		8
#define COMPRESSABLE(l)		(((l) == MODE_LEN) || ((l) == MODE_LEN2))
#define N_COMPRESSORS		10
#define MAX_MODE_LEN		16
#define	MAX_NETNODES		4	// max computers in a game
#define MAX_PACKET		256	// max packet length
#define	CMD_SEND		1
#define	CMD_GET			2
#define	GAMECOM_ID		0x12345678l

struct Setup {
  int game;
  int ticdup;
  char pwad[32];
};

struct GameCom {
  long id;
  int intnum;		/* DOOM executes an int to send commands */

/* communication between DOOM and the driver */
  int command;	/* CMD_SEND or CMD_GET */
  int remotenode;	/* dest for send, set by get (-1 = no packet) */
  int datalength;	/* bytes in doomdata to be sent / bytes read */

/* info common to all nodes */
  int numnodes;	/* console is allways node 0 */
  int ticdup;		/* 1 = no duplication, 2-5 = dup for slow nets */
  int extratics;	/* 1 = send a backup tic in every packet */
  int deathmatch;	/* 1 = deathmatch */
  int savegame;	/* -1 = new game, 0-5 = load savegame */
  int episode;	/* 1-3 */
  int map;		/* 1-9 */
  int skill;		/* 1-5 */

/* info specific to this node */
  int consoleplayer;	/* 0-3 = player number */
  int numplayers;	/* 1-4 */
  int angleoffset;	/* 1 = left, 0 = center, -1 = right */
  int drone;		/* 1 = drone */

/* packet data to be sent */
  byte data[MAX_PACKET];
};

extern const int		cMethod[MODE_LEN + MODE_LEN2];
extern const char		*gameName[N_GAMES];
extern int			noMonsters;
extern int			respawn;
extern GameCom		        gameCom;
extern Setup			setup;

void			compressInit();
void			compressDeinit();

#endif
