#include <dos.h>
#include <string.h>
#include "x_macros.h"
#include "packet.hpp"
#include "port.hpp"
#include "ipx.hpp"

#define SAMPLE_ECB

void				IPXinit();
void				IPXdeInit();
void				IPXcheck();

int                             IPXmutex;
word				nRecb;

static void __far		IPX_Handler();
static void __far		INT2f_Handler();
static void __far		INT7a_Handler();
static word                     byteSwap(word w);
static void			dummy();
extern void			IPX_HandlerStart1();
extern void			IPX_HandlerStart2();
extern void			IPX_HandlerFinish1();
extern void			IPX_HandlerFinish2();
extern void			INT2f_Body();

static void __interrupt		(*oldINT2f_Handler)();
static void __interrupt		(*oldINT7a_Handler)();
static word			nSockets;
static word                     rECBhead, rECBtail;
static ECBrec __far		*rECB[64];
static IPXrec __far		*IPXp;
#ifdef DEBUG
static dword		maxRecb;
static dword		maxFragmentCount;
static dword		nOpenSocket;
static dword		nCloseSocket;
static dword		nGetLocalTarget;
static dword		nSendPacket;
static dword		nListenForPacket;
static dword            nCancelEvent;
static dword		nGetLocalAddress;
static dword		nRelinquishControl;
static dword		nInstallationCheck;
static dword		nGetMaxPacketSize;
static dword		nIPXchecks;
static dword            nIdropped, nOdropped;
static dword		nRcvd;
static word		unknownIPX;
static word		maxPacketLen;
static word             nSavedSocket;
static word             savedSocket[16];
#ifdef SAMPLE_ECB
static word             nSavedECB;
static ECBrec           savedECB[32];
#endif
#ifdef SAMPLE_IPX
static word             nSavedIPX;
static IPXrec           savedIPX[32];
#endif
#endif

void IPXinit() {
  void __interrupt(*__far*p)() = (void __interrupt(*__far*)())dummy;
  oldINT2f_Handler = _dos_getvect(0x2f);
  *p = oldINT2f_Handler;
  _dos_setvect(0x2f, (void __interrupt(*)())INT2f_Handler);
  oldINT7a_Handler = _dos_getvect(0x7a);
  _dos_setvect(0x7a, (void __interrupt(*)())INT7a_Handler);
}

void IPXdeInit() {
#ifdef DEBUG
  int i;
  FILE *f = fopen("debug.txt", "at");
  fprintf(f, "--- IPX Module Debug Info --------------------------------------\n");
  fprintf(f, "maxRecb:             %lu\n", maxRecb);
  fprintf(f, "maxFragmentCount:    %lu\n", maxFragmentCount);
  fprintf(f, "nOpenSocket:         %lu\n", nOpenSocket);
  fprintf(f, "nCloseSocket:        %lu\n", nCloseSocket);
  fprintf(f, "nGetLocalTarget:     %lu\n", nGetLocalTarget);
  fprintf(f, "nSendPacket:         %lu\n", nSendPacket);
  fprintf(f, "nListenForPacket:    %lu\n", nListenForPacket);
  fprintf(f, "nCancelEvent:        %lu\n", nCancelEvent);
  fprintf(f, "nGetLocalAddress:    %lu\n", nGetLocalAddress);
  fprintf(f, "nRelinquishControl:  %lu\n", nRelinquishControl);
  fprintf(f, "nInstallationCheck:  %lu\n", nInstallationCheck);
  fprintf(f, "nGetMaxPacketSize:   %lu\n", nGetMaxPacketSize);
  fprintf(f, "nIPXchecks:          %lu\n", nIPXchecks);
  fprintf(f, "nRcvd:               %lu\n", nRcvd);
  fprintf(f, "nIdropped:           %lu\n", nIdropped);
  fprintf(f, "nOdropped:           %lu\n", nOdropped);
  fprintf(f, "unknownIPX:          0x%04x\n", unknownIPX);
  fprintf(f, "maxPacketLen:        %u\n", maxPacketLen);
  fprintf(f, "sockets:             ");
  for (i = 0; i < nSavedSocket; i++)
    fprintf(f, "0x%04x ", byteSwap(savedSocket[i]));
  fprintf(f, "\n");
#ifdef SAMPLE_ECB
  for (i = 0; i < nSavedECB; i++) {
    fprintf(f, "\n");
    fprintf(f, "ESRaddress:     %Fp\n", savedECB[i].ESRaddress);
    fprintf(f, "ECBsocket:      0x%04x\n", byteSwap(savedECB[i].ECBsocket));
    fprintf(f, "fragmentCount:  %u\n", savedECB[i].fragmentCount);
    fprintf(f, "fSize:          %u\n", savedECB[i].fSize);
    fprintf(f, "f2Size:         %u\n", savedECB[i].f2Size);
  }
#endif
#ifdef SAMPLE_IPX
  for (i = 0; i < nSavedIPX; i++) {
    fprintf(f, "\n");
    fprintf(f, "packetLength:            %u\n", byteSwap(savedIPX[i].packetLength));
    fprintf(f, "packetTransportControl:  %u\n", savedIPX[i].packetTransportControl);
    fprintf(f, "packetType:              %u\n", savedIPX[i].packetType);
    fprintf(f, "dNetwork:                0x");
    for (int j = 0; j < 4; j++)
      fprintf(f, "%02x", (word)savedIPX[i].dNetwork[j]);
    fprintf(f, "\n");
    fprintf(f, "dNode:                   0x");
    for (j = 0; j < 6; j++)
      fprintf(f, "%02x", (word)savedIPX[i].dNode[j]);
    fprintf(f, "\n");
    fprintf(f, "dSocket:                 0x%04x\n", byteSwap(savedIPX[i].dSocket));
    fprintf(f, "sNetwork:                0x");
    for (j = 0; j < 4; j++)
      fprintf(f, "%02x", (word)savedIPX[i].sNetwork[j]);
    fprintf(f, "\n");
    fprintf(f, "sNode:                   0x");
    for (j = 0; j < 6; j++)
      fprintf(f, "%02x", (word)savedIPX[i].sNode[j]);
    fprintf(f, "\n");
    fprintf(f, "sSocket:                 0x%04x\n", byteSwap(savedIPX[i].sSocket));
  }
#endif
  fclose(f);
#endif
  _dos_setvect(0x2f, oldINT2f_Handler);
  _dos_setvect(0x7a, oldINT7a_Handler);
}

void IPXcheck() {
  static word i, n;
  static ECBrec __far *ECBp;
  static byte __far *byteP;
  static byte *packet;
  static int _localStack;
  // We only need to set up a stack if we were called by the PORT module --
  // otherwise, there is a stack already set up for us to use.
#ifdef DEBUG
  nIPXchecks++;
#endif
  _localStack = !localStack;
  if (_localStack) setLocalStack();
  while (nRecb && nPacketsWaiting) {
    if (getPacket()) continue;
    if (packetLen < 2 * sizeof(word)) continue;
    packet = ::packet;
    i = rECBhead;
    while (i != rECBtail) {
      if (rECB[i]->ECBsocket == *((word*)packet + 1)) {
        n = rECB[i]->fSize;
        if (rECB[i]->fragmentCount == 2) n += rECB[i]->f2Size;
        n -= sizeof(IPXrec);
        if (n >= packetLen - 2 * sizeof(word)) break;
      }
      if (++i == 64) i = 0;
    }
    if (i == rECBtail) {
#ifdef DEBUG
      nIdropped++;
#endif
      continue;
    }
    ECBp = rECB[i];
#ifdef SAMPLE_ECB
    if (nSavedECB < 32) savedECB[nSavedECB++] = *ECBp;
#endif
    rECB[i] = rECB[rECBhead];
    if (++rECBhead == 64) rECBhead = 0;
    nRecb--;
#ifdef DEBUG
    if (ECBp->fragmentCount > maxFragmentCount)
      maxFragmentCount = ECBp->fragmentCount;
#endif
    _fmemset(ECBp->immediateAddress, 0, sizeof(NodeAddr));
    ECBp->immediateAddress[5] = remoteAddr + 1;
    IPXp = (IPXrec __far*)ECBp->fAddress;
    _fmemset(IPXp, 0, sizeof(IPXrec));
    IPXp->sSocket = *(word*)packet;
    IPXp->dSocket = *((word*)packet + 1);
    if (!IPXp->sSocket) IPXp->sSocket = IPXp->dSocket;
    packet += 2 * sizeof(word);
    packetLen -= 2 * sizeof(word);
    IPXp->packetType = 4;
    IPXp->packetLength = byteSwap(packetLen + sizeof(IPXrec));
    IPXp->sNetwork[3] = 1;
    IPXp->sNode[5] = remoteAddr + 1;
    IPXp->dNetwork[3] = 1;
    IPXp->dNode[5] = nodeAddr + 1;
    if (ECBp->fSize > sizeof(IPXrec)) {
      byteP = (byte __far*)IPXp + sizeof(IPXrec);
      n = min(ECBp->fSize - sizeof(IPXrec), packetLen);
      _fmemcpy(byteP, packet, n);
      packetLen -= n;
    }
    if (packetLen)
      _fmemcpy(ECBp->f2Address,
               packet + ECBp->fSize - sizeof(IPXrec),
               packetLen);
    ECBp->completionCode = 0;
    ECBp->inUseFlag = 0;
    if (ECBp->ESRaddress) {
      setAL(0xff);
      setES(FP_SEG(ECBp));
      setSI(FP_OFF(ECBp));
      pushf(); cli();
      ECBp->ESRaddress();
      popf();
    }
#ifdef DEBUG
    nRcvd++;
#endif
  }
  if (_localStack) unsetLocalStack();
}

void __far IPX_Handler() {
  static int _localStack;
  int i;
  ECBrec __far *sECB, __far *ECBp;
  word socket, __AX, __BX, __DX, __ES, __SI, __DI;
  LocalAddr __far *localAddrP;
  NodeAddr __far *nodeAddrP;
  byte res, __far *byteP;
  byte *packet;
  word retVal;
  IPX_HandlerStart1();
  if (IPXmutex == 1) {
    _localStack = !localStack;
    if (_localStack) setLocalStack();
  }
  IPX_HandlerStart2();
  __AX = getAX(); __BX = getBX(); __DX = getDX(); __ES = getES(); __SI = getSI(); __DI = getDI();
  switch (__BX) {
    case 0x00:			// Open Socket
#ifdef DEBUG
      nOpenSocket++;
#endif
      if (__DX) retVal = __DX;
      else {
        retVal = byteSwap(0x4000 + nSockets);
        if (++nSockets == 16) nSockets = 0;
      }
#ifdef DEBUG
      if (nSavedSocket < 16)
        savedSocket[nSavedSocket++] = retVal;
#endif
      res = 0;
      break;
    case 0x01:			// Close Socket
#ifdef DEBUG
      nCloseSocket++;
#endif
      socket = __DX;
      i = rECBhead;
      while (i != rECBtail) {
        if (rECB[i]->ECBsocket == socket) {
          rECB[i]->completionCode = 0xfc;
          rECB[i]->inUseFlag = 0;
          rECB[i] = rECB[rECBhead];
          if (++rECBhead == 64) rECBhead = 0;
          nRecb--;
        }
        if (++i == 64) i = 0;
      }
      break;
    case 0x02:                  // Get Local Target
#ifdef DEBUG
      nGetLocalTarget++;
#endif
      localAddrP = (LocalAddr __far*)MK_FP(__ES, __SI);
      nodeAddrP = (NodeAddr __far*)MK_FP(__ES, __DI);
      _fmemcpy(nodeAddrP, localAddrP->node, sizeof(NodeAddr));
      retVal = 9;
      res = 0;
      break;
    case 0x03:			// Send Packet
#ifdef DEBUG
      nSendPacket++;
#endif
      packet = ::packet;
      sECB = (ECBrec __far*)MK_FP(__ES, __SI);
      IPXp = (IPXrec __far*)sECB->fAddress;
#ifdef SAMPLE_IPX
      if (nSavedIPX < 32) savedIPX[nSavedIPX++] = *IPXp;
#endif
      remoteAddr = IPXp->dNode[5];
      if (remoteAddr == 0xff) remoteAddr = nodeAddr;
      else remoteAddr--;
      packetLen = sECB->fSize - sizeof(IPXrec);
      if (sECB->fragmentCount == 2) packetLen += sECB->f2Size;
      *(word*)packet = sECB->ECBsocket;
      *((word*)packet + 1) = IPXp->dSocket;
      packet += 2 * sizeof(word);
      packetLen += 2 * sizeof(word);
#ifdef DEBUG
      if (packetLen > maxPacketLen) maxPacketLen = packetLen;
#endif
      if (packetLen > MAX_PACKET ||
          (remoteAddr != nodeAddr &&
	   (remoteAddr > maxAddr || !nodeExists[remoteAddr])))
      {
#ifdef DEBUG
        nOdropped++;
#endif
        break;
      }
      if (sECB->fSize > sizeof(IPXrec)) {
	byteP = (byte __far*)IPXp + sizeof(IPXrec);
	_fmemcpy(packet, byteP, sECB->fSize - sizeof(IPXrec));
      }
      if (sECB->fragmentCount == 2)
	_fmemcpy(packet + sECB->fSize - sizeof(IPXrec),
                 sECB->f2Address, sECB->f2Size);
      if (remoteAddr == nodeAddr) broadcastPacket();
      else sendPacket();
      sECB->completionCode = 0;
      sECB->inUseFlag = 0;
      if (sECB->ESRaddress) {
        setAL(0xff);
        setES(FP_SEG(sECB));
        setSI(FP_OFF(sECB));
        pushf(); cli();
        sECB->ESRaddress();
        popf();
      }
      res = 0;
      break;
    case 0x04:			// Listen for Packet
#ifdef DEBUG
      nListenForPacket++;
#endif
      ECBp = (ECBrec __far*)MK_FP(__ES, __SI);
      nRecb++;
#ifdef DEBUG
      if (nRecb > maxRecb) maxRecb = nRecb;
#endif
      ECBp->inUseFlag = 0xfe;
      rECB[rECBtail] = ECBp; if (++rECBtail == 64) rECBtail = 0;
      if (nPacketsWaiting && IPXmutex == 1) IPXcheck();
      res = 0;
      break;
    case 0x06:                  // Cancel Event
#ifdef DEBUG
      nCancelEvent++;
#endif
      ECBp = (ECBrec __far*)MK_FP(__ES, __SI);
      i = rECBhead;
      while (i != rECBtail) {
        if (rECB[i] == ECBp) {
          rECB[i]->completionCode = 0xfc;
          rECB[i]->inUseFlag = 0;
          rECB[i] = rECB[rECBhead];
          if (++rECBhead == 64) rECBhead = 0;
          nRecb--;
          break;
        }
        if (++i == 64) i = 0;
      }
      res = 0;
      break;
    case 0x09:			// Get Local Address
#ifdef DEBUG
      nGetLocalAddress++;
#endif
      localAddrP = (LocalAddr __far*)MK_FP(__ES, __SI);
      _fmemset(localAddrP, 0, sizeof(LocalAddr));
      localAddrP->network[3] = 1;
      localAddrP->node[5] = nodeAddr + 1;
      break;
    case 0x0a:			// Relinquish Control
#ifdef DEBUG
      nRelinquishControl++;
#endif
      if (nPacketsWaiting && nRecb && IPXmutex == 1) IPXcheck();
      break;
    case 0x10:			// Installation Check
#ifdef DEBUG
      nInstallationCheck++;
#endif
      res = 0xff;
      break;
    case 0x1a:			// Get Max Packet Size
#ifdef DEBUG
      nGetMaxPacketSize++;
#endif
      retVal = MAX_PACKET + sizeof(IPXrec);
      break;
    default:			// Aieeee
      __BX = 0xff;
#ifdef DEBUG
      unknownIPX = __BX;
#endif
  }
  switch (__BX) {
    case 0x00: IPX_HandlerFinish1(); setAL(res); setDX(retVal); break;
    case 0x02: IPX_HandlerFinish1(); setAL(res); setCX(retVal); break;
    case 0x04: IPX_HandlerFinish1(); setAL(res); break;
    case 0x06: IPX_HandlerFinish1(); setAL(res); break;
    case 0x10: IPX_HandlerFinish1(); setAL(res); setBX(0xffff); setCX(64); setDX(64); break;
    case 0x1a: IPX_HandlerFinish1(); setAX(retVal); break;
    case 0xff: IPX_HandlerFinish1(); setAL(0xff); break;
    default: IPX_HandlerFinish1();
  }
  if (IPXmutex == 1 && _localStack) unsetLocalStack();
  IPX_HandlerFinish2();
}

void __far INT2f_Handler() {
  INT2f_Body();
}

void __far INT7a_Handler() {
  IPX_Handler();
  iret();
}

word byteSwap(word w) {
  return ((w >> 8) | (w << 8));
}

void dummy() {
  int i, j = 0;
  for (i = 0; i < 256; i++)
    j += i;
  for (i = 0; i < 256; i++)
    j -= i;
}

#pragma aux IPX_HandlerStart1 =			\
	"add	sp, 0x0e"			\
	"pop	bp"				\
	"pop	di"				\
	"pop	si"				\
	"pop	dx"				\
	"pop	cx"				\
	"pop	bx"				\
	"pushf"					\
	"push	bp"				\
	"mov	bp, sp"				\
	"sub	sp, 0x12"			\
	"push	ds"				\
	"push	es"				\
	"push	ax"				\
	"mov	ax, SEG nSockets"		\
	"mov	ds, ax"				\
	"pop	ax"				;

#pragma aux IPX_HandlerStart2 =			\
	"push	ax"				\
	"push	bx"				\
	"push	cx"				\
	"push	dx"				\
	"push	si"				\
	"push	di"				\
	"inc	IPXmutex"			;

#pragma aux IPX_HandlerFinish1 =		\
	"pop	di"				\
	"pop	si"				\
	"pop	dx"				\
	"pop	cx"				\
	"pop	bx"				\
	"pop	ax"				;

#pragma aux IPX_HandlerFinish2 =		\
        "dec	IPXmutex"			\
	"pop	es"				\
	"pop	ds"				\
	"mov	sp, bp"				\
	"pop	bp"				\
	"popf"					\
	"retf"					;

#pragma aux INT2f_Body =			\
	"cmp	ax, 0x7a00"			\
	"jne	l0"				\
	"mov	ax, SEG IPX_Handler"		\
	"mov	es, ax"				\
	"mov	di, OFFSET IPX_Handler"		\
	"mov	ax, 0x7aff"			\
	"iret"					\
"l0:	jmp     DWORD PTR cs:dummy"		;
